---
product: "AG Studio"
title: "User Interface"
description: "The authoring interface organises common actions into panels and toolbars."
framework: react
version: "3.0.0"
related:
    - title: "Page Settings"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/page-settings/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/react/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# User Interface

The authoring interface organises common actions into panels and toolbars.

AG Studio combines a report-building interface with a data engine. It provides the layout, panels, widget configuration, data processing, calculations, filtering, visualisation, and grid-aware layout authoring.

> **Note**
>
> Some features - such as saving and publishing, available widget types, and navigation - are controlled by your application, not AG Studio. If something appears to be missing or unavailable, speak to your developer or administrator.

In the default layout, the page sits alongside the panels that are used to build and configure it. The example below shows an empty page in Edit Mode with the default Panel layout. From left to right, the Panels are: Filters, Edit (Compose), and Data.

#### Empty Dashboard

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [{ id: "a" }],
      selectedPageId: "a",
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Empty Dashboard](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/empty/reactFunctionalTs/)

## Modes

AG Studio separates viewing a report from changing its structure and configuration. The button or control to switch between modes is provided by the application; AG Studio provides the methods to change modes programmatically.

In Edit mode, widgets can be added and configured, and the page layout can be changed. Widgets remain fully interactive - tooltips, filters, selections, and other widget behaviours work exactly as they do in View mode. Layout actions (move and resize) are still available alongside these interactions. When moving or resizing, widgets snap to the [Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/react/page-settings/#layout-grid), and placement is clamped to the nearest valid position if a widget would exceed the layout bounds.

In View mode, the page structure is locked and editing panels are hidden. Widgets can still be interacted with - for example through filters, selections, and tooltips - but they cannot be moved, resized, or reconfigured. The Table widget is an exception and is not interactive in either mode.

## Panels

Panels are where most authoring actions happen to configure the page. The set of Panels shown depends on the application setup.

Each Panel includes a search box. Search applies to the current Panel contents, and if the Panel has tabs, search is scoped to the active tab. Search also works across the Panel hierarchy (for example, across groups and data sources) as text is typed.

### Data Panel

The Data Panel shows the Fields configured by the application developer and is used to select Fields, calculated Fields, and Measures when configuring Widgets. For detailed information on how data is structured and used, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/react/data-setup/).

### Edit Panel

The Edit Panel is contextual and updates based on what is selected on the layout or in the Panels. This allows the Panel to show only the relevant options for the task at hand.

- When nothing is selected, the Edit Panel displays the default view with the Widgets and Page tabs. This is where [Widget Types](https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/#widget-types) can be chosen to add to the page and [Page-Level Settings](https://www.ag-grid.com/studio/archive/3.0.0/react/page-settings/) can be adjusted.
- When a Widget is selected on the layout, the Panel switches to Widget configuration mode, showing the Setup and Format tabs. For comprehensive guidance on configuring Widgets, see [Widgets](https://www.ag-grid.com/studio/archive/3.0.0/react/widgets/).
- If a data field is selected, the Panel can switch to a data-field view that displays field-specific options.
- To return to the default view at any time, the current selection can be cleared or the close action available in the Panel can be used.

Try interacting with the example below to see the Edit Panel update contextually as you select different elements.

#### Edit Panel

```tsx
"use client";

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const StudioExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [data, setData] = useState<AgDataSourcesDefinition | AgDataEngine>();
  const initialState = useMemo<AgReportState>(() => {
    return {
      pages: [
        {
          id: "a",
          widgets: {
            "total-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.total" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Total Medals",
                },
              },
            },
          },
          widgetLayout: {
            "total-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 6,
            },
          },
        },
      ],
      selectedPageId: "a",
    };
  }, []);
  const panels = useMemo<AgPanelConfig>(() => {
    return {
      edit: {
        right: ["edit", "data"],
      },
    };
  }, []);

  const onApiReady = useCallback((params: AgStudioApiReadyEvent) => {
    fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setData({ sources: [{ id: "medals", data }] }));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
        <AgStudio
          style={studioStyle}
          className="my-studio-container"
          data={data}
          initialState={initialState}
          mode={"edit"}
          panels={panels}
          onApiReady={onApiReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <StudioExample />
  </StrictMode>,
);
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/edit-panel/reactFunctionalTs/)

### Filters Panel

The Filters Panel is used to manage Filters that apply to the report. Depending on the application, this can include page-level Filters, Widget-level Filters, and cross-filtering. For detailed information on Filter types and usage, see [Filters](https://www.ag-grid.com/studio/archive/3.0.0/react/filters/).

### Chat Panel

The chat panel is a conversational interface for building dashboards using natural language. It is available when the application has configured AI support.

The panel is organised into three areas:

- Thread control - shown at the top of the panel. Displays the active thread name as a dropdown. Selecting it opens a list of available threads to switch between. A New button creates a new thread.
- Message area - shows the conversation history for the active thread. While the Assistant is processing, a "Thinking..." indicator is shown. A Stop button cancels the current request. When scrolled up, a Back to bottom button appears.
- Input - a text field at the bottom of the panel. Press Enter to send a message. Press Shift+Enter to insert a new line without sending.

Each thread holds an independent conversation history. Switching threads preserves the history of each.

For guidance on using the chat panel effectively, see [Working with AI](https://www.ag-grid.com/studio/archive/3.0.0/react/working-with-ai/).


---
product: "AG Studio"
title: "User Interface"
description: "The authoring interface organises common actions into panels and toolbars."
framework: vue
version: "3.0.0"
related:
    - title: "Page Settings"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/page-settings/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/vue/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# User Interface

The authoring interface organises common actions into panels and toolbars.

AG Studio combines a report-building interface with a data engine. It provides the layout, panels, widget configuration, data processing, calculations, filtering, visualisation, and grid-aware layout authoring.

> **Note**
>
> Some features - such as saving and publishing, available widget types, and navigation - are controlled by your application, not AG Studio. If something appears to be missing or unavailable, speak to your developer or administrator.

In the default layout, the page sits alongside the panels that are used to build and configure it. The example below shows an empty page in Edit Mode with the default Panel layout. From left to right, the Panels are: Filters, Edit (Compose), and Data.

#### Empty Dashboard

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [{ id: "a" }],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Empty Dashboard](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/empty/vue3/)

## Modes

AG Studio separates viewing a report from changing its structure and configuration. The button or control to switch between modes is provided by the application; AG Studio provides the methods to change modes programmatically.

In Edit mode, widgets can be added and configured, and the page layout can be changed. Widgets remain fully interactive - tooltips, filters, selections, and other widget behaviours work exactly as they do in View mode. Layout actions (move and resize) are still available alongside these interactions. When moving or resizing, widgets snap to the [Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/vue/page-settings/#layout-grid), and placement is clamped to the nearest valid position if a widget would exceed the layout bounds.

In View mode, the page structure is locked and editing panels are hidden. Widgets can still be interacted with - for example through filters, selections, and tooltips - but they cannot be moved, resized, or reconfigured. The Table widget is an exception and is not interactive in either mode.

## Panels

Panels are where most authoring actions happen to configure the page. The set of Panels shown depends on the application setup.

Each Panel includes a search box. Search applies to the current Panel contents, and if the Panel has tabs, search is scoped to the active tab. Search also works across the Panel hierarchy (for example, across groups and data sources) as text is typed.

### Data Panel

The Data Panel shows the Fields configured by the application developer and is used to select Fields, calculated Fields, and Measures when configuring Widgets. For detailed information on how data is structured and used, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/vue/data-setup/).

### Edit Panel

The Edit Panel is contextual and updates based on what is selected on the layout or in the Panels. This allows the Panel to show only the relevant options for the task at hand.

- When nothing is selected, the Edit Panel displays the default view with the Widgets and Page tabs. This is where [Widget Types](https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/#widget-types) can be chosen to add to the page and [Page-Level Settings](https://www.ag-grid.com/studio/archive/3.0.0/vue/page-settings/) can be adjusted.
- When a Widget is selected on the layout, the Panel switches to Widget configuration mode, showing the Setup and Format tabs. For comprehensive guidance on configuring Widgets, see [Widgets](https://www.ag-grid.com/studio/archive/3.0.0/vue/widgets/).
- If a data field is selected, the Panel can switch to a data-field view that displays field-specific options.
- To return to the default view at any time, the current selection can be cleared or the close action available in the Panel can be used.

Try interacting with the example below to see the Edit Panel update contextually as you select different elements.

#### Edit Panel

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
  AgDataEngine,
  AgDataSourcesDefinition,
  AgPanelConfig,
  AgReportState,
  AgStudioApi,
  AgStudioApiReadyEvent,
  AgStudioMode,
  AgStudioProperties,
  enableStudioDevValidations,
} from "ag-studio";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableStudioDevValidations();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="display: flex; flex-direction: column; height: 100%">
      <ag-studio
        style="width: 100%; height: 100%;"
        class="my-studio-container"
        @api-ready="onApiReady"
        :initialState="initialState"
        :mode="mode"
        :panels="panels"
        :data="data"></ag-studio>
      </div>
        </div>
    `,
  components: {
    "ag-studio": AgStudio,
  },
  setup(props) {
    const studioApi = shallowRef<AgStudioApi | null>(null);
    const initialState = ref<AgReportState>({
      pages: [
        {
          id: "a",
          widgets: {
            "total-medals": {
              type: "value",
              dataMapping: {
                value: [{ id: "medals.total" }],
              },
              format: {
                title: {
                  enabled: true,
                  text: "Total Medals",
                },
              },
            },
          },
          widgetLayout: {
            "total-medals": {
              xTrack: 0,
              yTrack: 0,
              xSpan: 8,
              ySpan: 6,
            },
          },
        },
      ],
      selectedPageId: "a",
    });
    const mode = ref<AgStudioMode>("edit");
    const panels = ref<AgPanelConfig>({
      edit: {
        right: ["edit", "data"],
      },
    });
    const data = ref<AgDataSourcesDefinition | AgDataEngine>(null);

    const onApiReady = (params: AgStudioApiReadyEvent) => {
      studioApi.value = params.api;

      const toStudioData = (data) => ({ sources: [{ id: "medals", data }] });

      fetch("https://www.ag-grid.com/studio/archive/3.0.0/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((respData) => (data.value = toStudioData(respData)));
    };

    return {
      studioApi,
      initialState,
      mode,
      panels,
      data,
      onApiReady,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/edit-panel/vue3/)

### Filters Panel

The Filters Panel is used to manage Filters that apply to the report. Depending on the application, this can include page-level Filters, Widget-level Filters, and cross-filtering. For detailed information on Filter types and usage, see [Filters](https://www.ag-grid.com/studio/archive/3.0.0/vue/filters/).

### Chat Panel

The chat panel is a conversational interface for building dashboards using natural language. It is available when the application has configured AI support.

The panel is organised into three areas:

- Thread control - shown at the top of the panel. Displays the active thread name as a dropdown. Selecting it opens a list of available threads to switch between. A New button creates a new thread.
- Message area - shows the conversation history for the active thread. While the Assistant is processing, a "Thinking..." indicator is shown. A Stop button cancels the current request. When scrolled up, a Back to bottom button appears.
- Input - a text field at the bottom of the panel. Press Enter to send a message. Press Shift+Enter to insert a new line without sending.

Each thread holds an independent conversation history. Switching threads preserves the history of each.

For guidance on using the chat panel effectively, see [Working with AI](https://www.ag-grid.com/studio/archive/3.0.0/vue/working-with-ai/).


---
product: "AG Studio"
title: "User Interface"
description: "The authoring interface organises common actions into panels and toolbars."
framework: angular
version: "3.0.0"
related:
    - title: "Page Settings"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/page-settings/"
    - title: "Keyboard Shortcuts"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/keyboard-shortcuts/"
    - title: "Accessibility"
      url: "https://www.ag-grid.com/studio/archive/3.0.0/angular/accessibility/"
llms: "https://www.ag-grid.com/studio/archive/3.0.0/llms.txt"
---

# User Interface

The authoring interface organises common actions into panels and toolbars.

AG Studio combines a report-building interface with a data engine. It provides the layout, panels, widget configuration, data processing, calculations, filtering, visualisation, and grid-aware layout authoring.

> **Note**
>
> Some features - such as saving and publishing, available widget types, and navigation - are controlled by your application, not AG Studio. If something appears to be missing or unavailable, speak to your developer or administrator.

In the default layout, the page sits alongside the panels that are used to build and configure it. The example below shows an empty page in Edit Mode with the default Panel layout. From left to right, the Panels are: Filters, Edit (Compose), and Data.

#### Empty Dashboard

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Empty Dashboard](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/empty/angular/)

## Modes

AG Studio separates viewing a report from changing its structure and configuration. The button or control to switch between modes is provided by the application; AG Studio provides the methods to change modes programmatically.

In Edit mode, widgets can be added and configured, and the page layout can be changed. Widgets remain fully interactive - tooltips, filters, selections, and other widget behaviours work exactly as they do in View mode. Layout actions (move and resize) are still available alongside these interactions. When moving or resizing, widgets snap to the [Layout Grid](https://www.ag-grid.com/studio/archive/3.0.0/angular/page-settings/#layout-grid), and placement is clamped to the nearest valid position if a widget would exceed the layout bounds.

In View mode, the page structure is locked and editing panels are hidden. Widgets can still be interacted with - for example through filters, selections, and tooltips - but they cannot be moved, resized, or reconfigured. The Table widget is an exception and is not interactive in either mode.

## Panels

Panels are where most authoring actions happen to configure the page. The set of Panels shown depends on the application setup.

Each Panel includes a search box. Search applies to the current Panel contents, and if the Panel has tabs, search is scoped to the active tab. Search also works across the Panel hierarchy (for example, across groups and data sources) as text is typed.

### Data Panel

The Data Panel shows the Fields configured by the application developer and is used to select Fields, calculated Fields, and Measures when configuring Widgets. For detailed information on how data is structured and used, see [Data Setup](https://www.ag-grid.com/studio/archive/3.0.0/angular/data-setup/).

### Edit Panel

The Edit Panel is contextual and updates based on what is selected on the layout or in the Panels. This allows the Panel to show only the relevant options for the task at hand.

- When nothing is selected, the Edit Panel displays the default view with the Widgets and Page tabs. This is where [Widget Types](https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/#widget-types) can be chosen to add to the page and [Page-Level Settings](https://www.ag-grid.com/studio/archive/3.0.0/angular/page-settings/) can be adjusted.
- When a Widget is selected on the layout, the Panel switches to Widget configuration mode, showing the Setup and Format tabs. For comprehensive guidance on configuring Widgets, see [Widgets](https://www.ag-grid.com/studio/archive/3.0.0/angular/widgets/).
- If a data field is selected, the Panel can switch to a data-field view that displays field-specific options.
- To return to the default view at any time, the current selection can be cleared or the close action available in the Panel can be used.

Try interacting with the example below to see the Edit Panel update contextually as you select different elements.

#### Edit Panel

```ts
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component.ts';

const app = bootstrapApplication(AppComponent, {
    providers: [provideHttpClient()],
});
```

[Live example: Edit Panel](https://www.ag-grid.com/studio/archive/3.0.0/examples/user-interface/edit-panel/angular/)

### Filters Panel

The Filters Panel is used to manage Filters that apply to the report. Depending on the application, this can include page-level Filters, Widget-level Filters, and cross-filtering. For detailed information on Filter types and usage, see [Filters](https://www.ag-grid.com/studio/archive/3.0.0/angular/filters/).

### Chat Panel

The chat panel is a conversational interface for building dashboards using natural language. It is available when the application has configured AI support.

The panel is organised into three areas:

- Thread control - shown at the top of the panel. Displays the active thread name as a dropdown. Selecting it opens a list of available threads to switch between. A New button creates a new thread.
- Message area - shows the conversation history for the active thread. While the Assistant is processing, a "Thinking..." indicator is shown. A Stop button cancels the current request. When scrolled up, a Back to bottom button appears.
- Input - a text field at the bottom of the panel. Press Enter to send a message. Press Shift+Enter to insert a new line without sending.

Each thread holds an independent conversation history. Switching threads preserves the history of each.

For guidance on using the chat panel effectively, see [Working with AI](https://www.ag-grid.com/studio/archive/3.0.0/angular/working-with-ai/).
